5870f52604eb77220357859d8f018f0096b31893
[libav.git] / tests / fate.sh
1 #! /bin/sh
2
3 config=$1
4
5 die(){
6 echo "$@"
7 exit 1
8 }
9
10 test -r "$config" || die "usage: fate.sh <config>"
11
12 workdir=$(dirname $config)
13 make=make
14
15 . "$config"
16
17 test -n "$slot" || die "slot not specified"
18 test -n "$repo" || die "repo not specified"
19 test -d "$samples" || die "samples location not specified"
20
21 lock(){
22 lock=$1/fate.lock
23 (set -C; exec >$lock) 2>/dev/null || return
24 trap 'rm $lock' EXIT
25 }
26
27 checkout(){
28 case "$repo" in
29 file:*|/*) src="${repo#file:}" ;;
30 git:*) git clone "$repo" "$src" ;;
31 svn:*) svn co "$repo" "$src" ;;
32 esac
33 }
34
35 update()(
36 cd ${src} || return
37 case "$repo" in
38 git:*) git pull ;;
39 svn:*) svn up ;;
40 esac
41 )
42
43 configure()(
44 cd ${build} || return
45 ${src}/configure \
46 --prefix="${inst}" \
47 --samples="${samples}" \
48 ${arch:+--arch=$arch} \
49 ${cpu:+--cpu="$cpu"} \
50 ${cross_prefix:+--cross-prefix="$cross_prefix"} \
51 ${cc:+--cc="$cc"} \
52 ${target_os:+--target-os="$target_os"} \
53 ${sysroot:+--sysroot="$sysroot"} \
54 ${target_exec:+--target-exec="$target_exec"} \
55 ${target_path:+--target-path="$target_path"} \
56 ${extra_cflags:+--extra-cflags="$extra_cflags"} \
57 ${extra_ldflags:+--extra-ldflags="$extra_ldflags"} \
58 ${extra_libs:+--extra-libs="$extra_libs"} \
59 ${extra_conf}
60 )
61
62 compile()(
63 cd ${build} || return
64 ${make} ${makeopts} && ${make} install
65 )
66
67 fate()(
68 cd ${build} || return
69 ${make} ${makeopts} -k fate
70 )
71
72 clean(){
73 rm -r ${build} ${inst}
74 }
75
76 report(){
77 date=$(date -u +%Y%m%d%H%M%S)
78 echo "fate:0:${date}:${slot}:${version}:$1:$2" >report
79 cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report
80 test -n "$fate_recv" && tar cz report *.log | $fate_recv
81 }
82
83 fail(){
84 report "$@"
85 exit
86 }
87
88 mkdir -p ${workdir} || die "Error creating ${workdir}"
89 lock ${workdir} || die "${workdir} locked"
90 cd ${workdir} || die "cd ${workdir} failed"
91
92 src=${workdir}/src
93 build=${workdir}/build
94 inst=${workdir}/install
95 report=tests/data/fate/report
96
97 test -d "$src" && update || checkout || die "Error fetching source"
98
99 cd ${workdir}
100
101 version=$(${src}/version.sh ${src})
102 test "$version" = "$(cat version 2>/dev/null)" && exit 0
103 echo ${version} >version
104
105 rm -rf "${build}"
106 mkdir -p ${build}
107
108 configure >configure.log 2>&1 || fail $? "error configuring"
109 compile >compile.log 2>&1 || fail $? "error compiling"
110 fate >test.log 2>&1 || fail $? "error testing"
111 report 0 success
112 clean